diff --git a/dist/handlebars.js b/dist/handlebars.js
index 9c653ee72..26d920778 100644
--- a/dist/handlebars.js
+++ b/dist/handlebars.js
@@ -24,8 +24,7 @@ THE SOFTWARE.
 
 // lib/handlebars/base.js
 
-/*jshint eqnull:true*/
-this.Handlebars = {};
+var Handlebars = {};
 
 (function(Handlebars) {
 
@@ -62,8 +61,6 @@ var toString = Object.prototype.toString, functionType = "[object Function]";
 Handlebars.registerHelper('blockHelperMissing', function(context, options) {
   var inverse = options.inverse || function() {}, fn = options.fn;
 
-
-  var ret = "";
   var type = toString.call(context);
 
   if(type === functionType) { context = context.call(this); }
@@ -170,7 +167,7 @@ Handlebars.registerHelper('log', function(context, options) {
   Handlebars.log(level, context);
 });
 
-}(this.Handlebars));
+}(Handlebars));
 ;
 // lib/handlebars/compiler/parser.js
 /* Jison generated parser */
@@ -646,6 +643,7 @@ function Parser () { this.yy = {}; }Parser.prototype = parser;parser.Parser = Pa
 return new Parser;
 })();;
 // lib/handlebars/compiler/base.js
+
 Handlebars.Parser = handlebars;
 
 Handlebars.parse = function(input) {
@@ -699,13 +697,13 @@ Handlebars.print = function(ast) {
     this.context      = context;
   };
 
-  var verifyMatch = function(open, close) {
-    if(open.original !== close.original) {
-      throw new Handlebars.Exception(open.original + " doesn't match " + close.original);
-    }
-  };
-
   Handlebars.AST.BlockNode = function(mustache, program, inverse, close) {
+    var verifyMatch = function(open, close) {
+      if(open.original !== close.original) {
+        throw new Handlebars.Exception(open.original + " doesn't match " + close.original);
+      }
+    };
+
     verifyMatch(mustache.id, close);
     this.type = "block";
     this.mustache = mustache;
@@ -851,7 +849,8 @@ Handlebars.SafeString.prototype.toString = function() {
       }
     }
   };
-})();;
+})();
+;
 // lib/handlebars/compiler/compiler.js
 
 /*jshint eqnull:true*/
@@ -2114,8 +2113,10 @@ Handlebars.compile = function(input, options) {
     return compiled.call(this, context, options);
   };
 };
+
 ;
 // lib/handlebars/runtime.js
+
 Handlebars.VM = {
   template: function(templateSpec) {
     // Just add water
diff --git a/dist/handlebars.runtime.js b/dist/handlebars.runtime.js
index f3811348d..e8b8a42af 100644
--- a/dist/handlebars.runtime.js
+++ b/dist/handlebars.runtime.js
@@ -24,8 +24,7 @@ THE SOFTWARE.
 
 // lib/handlebars/base.js
 
-/*jshint eqnull:true*/
-this.Handlebars = {};
+var Handlebars = {};
 
 (function(Handlebars) {
 
@@ -62,8 +61,6 @@ var toString = Object.prototype.toString, functionType = "[object Function]";
 Handlebars.registerHelper('blockHelperMissing', function(context, options) {
   var inverse = options.inverse || function() {}, fn = options.fn;
 
-
-  var ret = "";
   var type = toString.call(context);
 
   if(type === functionType) { context = context.call(this); }
@@ -170,7 +167,7 @@ Handlebars.registerHelper('log', function(context, options) {
   Handlebars.log(level, context);
 });
 
-}(this.Handlebars));
+}(Handlebars));
 ;
 // lib/handlebars/utils.js
 
@@ -234,8 +231,10 @@ Handlebars.SafeString.prototype.toString = function() {
       }
     }
   };
-})();;
+})();
+;
 // lib/handlebars/runtime.js
+
 Handlebars.VM = {
   template: function(templateSpec) {
     // Just add water
diff --git a/lib/handlebars.js b/lib/handlebars.js
index 8705269c4..7d85c2610 100644
--- a/lib/handlebars.js
+++ b/lib/handlebars.js
@@ -1,14 +1,32 @@
-var Handlebars = require("./handlebars/base");
-module.exports = Handlebars;
+var handlebars = require("./handlebars/base"),
 
 // Each of these augment the Handlebars object. No need to setup here.
 // (This is done to easily share code between commonjs and browse envs)
-require("./handlebars/utils");
+  utils = require("./handlebars/utils"),
+  compiler = require("./handlebars/compiler"),
+  runtime = require("./handlebars/runtime");
 
-require("./handlebars/compiler");
-require("./handlebars/runtime");
+var create = function() {
+  var hb = handlebars.create();
+
+  utils.attach(hb);
+  compiler.attach(hb);
+  runtime.attach(hb);
+
+  return hb;
+};
+
+var Handlebars = create();
+Handlebars.create = create;
+
+module.exports = Handlebars; // instantiate an instance
 
 // BEGIN(BROWSER)
 
 // END(BROWSER)
 
+// USAGE:
+// var handlebars = require('handlebars');
+
+// var singleton = handlebars.Handlebars,
+//  local = handlebars.create();
diff --git a/lib/handlebars/base.js b/lib/handlebars/base.js
index 04e9a529a..1a25b5cc8 100644
--- a/lib/handlebars/base.js
+++ b/lib/handlebars/base.js
@@ -1,7 +1,10 @@
+/*jshint eqnull: true */
+
+module.exports.create = function() {
+
 // BEGIN(BROWSER)
 
-/*jshint eqnull:true*/
-this.Handlebars = {};
+var Handlebars = {};
 
 (function(Handlebars) {
 
@@ -38,8 +41,6 @@ var toString = Object.prototype.toString, functionType = "[object Function]";
 Handlebars.registerHelper('blockHelperMissing', function(context, options) {
   var inverse = options.inverse || function() {}, fn = options.fn;
 
-
-  var ret = "";
   var type = toString.call(context);
 
   if(type === functionType) { context = context.call(this); }
@@ -146,9 +147,9 @@ Handlebars.registerHelper('log', function(context, options) {
   Handlebars.log(level, context);
 });
 
-}(this.Handlebars));
+}(Handlebars));
 
 // END(BROWSER)
 
-module.exports = this.Handlebars;
-
+return Handlebars;
+};
diff --git a/lib/handlebars/compiler/ast.js b/lib/handlebars/compiler/ast.js
index f4485237c..1ba1fcf73 100644
--- a/lib/handlebars/compiler/ast.js
+++ b/lib/handlebars/compiler/ast.js
@@ -1,4 +1,4 @@
-var Handlebars = require('./base');
+exports.attach = function(Handlebars) {
 
 // BEGIN(BROWSER)
 (function() {
@@ -39,13 +39,13 @@ var Handlebars = require('./base');
     this.context      = context;
   };
 
-  var verifyMatch = function(open, close) {
-    if(open.original !== close.original) {
-      throw new Handlebars.Exception(open.original + " doesn't match " + close.original);
-    }
-  };
-
   Handlebars.AST.BlockNode = function(mustache, program, inverse, close) {
+    var verifyMatch = function(open, close) {
+      if(open.original !== close.original) {
+        throw new Handlebars.Exception(open.original + " doesn't match " + close.original);
+      }
+    };
+
     verifyMatch(mustache.id, close);
     this.type = "block";
     this.mustache = mustache;
@@ -131,3 +131,6 @@ var Handlebars = require('./base');
 })();
 // END(BROWSER)
 
+return Handlebars;
+};
+
diff --git a/lib/handlebars/compiler/base.js b/lib/handlebars/compiler/base.js
index df8ced0b5..8ff1101d5 100644
--- a/lib/handlebars/compiler/base.js
+++ b/lib/handlebars/compiler/base.js
@@ -1,7 +1,9 @@
 var handlebars = require("./parser");
-var Handlebars = require("../base");
+
+exports.attach = function(Handlebars) {
 
 // BEGIN(BROWSER)
+
 Handlebars.Parser = handlebars;
 
 Handlebars.parse = function(input) {
@@ -18,4 +20,5 @@ Handlebars.print = function(ast) {
 };
 // END(BROWSER)
 
-module.exports = Handlebars;
+return Handlebars;
+};
diff --git a/lib/handlebars/compiler/compiler.js b/lib/handlebars/compiler/compiler.js
index 4a9a23fd7..84008043c 100644
--- a/lib/handlebars/compiler/compiler.js
+++ b/lib/handlebars/compiler/compiler.js
@@ -1,4 +1,8 @@
-var Handlebars = require("./base");
+var compilerbase = require("./base");
+
+exports.attach = function(Handlebars) {
+
+compilerbase.attach(Handlebars);
 
 // BEGIN(BROWSER)
 
@@ -1263,5 +1267,11 @@ Handlebars.compile = function(input, options) {
   };
 };
 
+
 // END(BROWSER)
 
+return Handlebars;
+
+};
+
+
diff --git a/lib/handlebars/compiler/index.js b/lib/handlebars/compiler/index.js
index e62c7684c..6ed8d2190 100644
--- a/lib/handlebars/compiler/index.js
+++ b/lib/handlebars/compiler/index.js
@@ -1,7 +1,16 @@
 // Each of these module will augment the Handlebars object as it loads. No need to perform addition operations
-module.exports = require("./base");
-require("./visitor");
-require("./printer");
+module.exports.attach = function(Handlebars) {
 
-require("./ast");
-require("./compiler");
+var visitor = require("./visitor"),
+    printer = require("./printer"),
+    ast = require("./ast"),
+    compiler = require("./compiler");
+
+visitor.attach(Handlebars);
+printer.attach(Handlebars);
+ast.attach(Handlebars);
+compiler.attach(Handlebars);
+
+return Handlebars;
+
+};
diff --git a/lib/handlebars/compiler/printer.js b/lib/handlebars/compiler/printer.js
index 853a4cace..1d96a91f8 100644
--- a/lib/handlebars/compiler/printer.js
+++ b/lib/handlebars/compiler/printer.js
@@ -1,6 +1,7 @@
-var Handlebars = require("./base");
+exports.attach = function(Handlebars) {
 
 // BEGIN(BROWSER)
+
 Handlebars.PrintVisitor = function() { this.padding = 0; };
 Handlebars.PrintVisitor.prototype = new Handlebars.Visitor();
 
@@ -128,4 +129,6 @@ Handlebars.PrintVisitor.prototype.comment = function(comment) {
 };
 // END(BROWSER)
 
-exports.PrintVisitor = Handlebars.PrintVisitor;
+return Handlebars;
+};
+
diff --git a/lib/handlebars/compiler/visitor.js b/lib/handlebars/compiler/visitor.js
index a557dd3db..5d0731407 100644
--- a/lib/handlebars/compiler/visitor.js
+++ b/lib/handlebars/compiler/visitor.js
@@ -1,4 +1,4 @@
-var Handlebars = require("./base");
+exports.attach = function(Handlebars) {
 
 // BEGIN(BROWSER)
 
@@ -9,5 +9,10 @@ Handlebars.Visitor.prototype = {
     return this[object.type](object);
   }
 };
+
 // END(BROWSER)
 
+return Handlebars;
+};
+
+
diff --git a/lib/handlebars/runtime.js b/lib/handlebars/runtime.js
index d9bcc6df3..805e10fbd 100644
--- a/lib/handlebars/runtime.js
+++ b/lib/handlebars/runtime.js
@@ -1,6 +1,7 @@
-var Handlebars = require("./base");
+exports.attach = function(Handlebars) {
 
 // BEGIN(BROWSER)
+
 Handlebars.VM = {
   template: function(templateSpec) {
     // Just add water
@@ -86,3 +87,6 @@ Handlebars.template = Handlebars.VM.template;
 
 // END(BROWSER)
 
+return Handlebars;
+
+};
diff --git a/lib/handlebars/utils.js b/lib/handlebars/utils.js
index 753903933..2a7861afe 100644
--- a/lib/handlebars/utils.js
+++ b/lib/handlebars/utils.js
@@ -1,4 +1,4 @@
-var Handlebars = require("./base");
+exports.attach = function(Handlebars) {
 
 // BEGIN(BROWSER)
 
@@ -63,5 +63,8 @@ Handlebars.SafeString.prototype.toString = function() {
     }
   };
 })();
+
 // END(BROWSER)
 
+return Handlebars;
+};
diff --git a/package.json b/package.json
index 6e719faee..7d9071643 100644
--- a/package.json
+++ b/package.json
@@ -1,7 +1,7 @@
 {
   "name": "handlebars",
   "description": "Extension of the Mustache logicless template language",
-  "version": "1.0.8",
+  "version": "1.0.9",
   "homepage": "http://www.handlebarsjs.com/",
   "keywords": [
     "handlebars mustache template html"
